from django.db.models import Q
from datetime import date
from datetime import timedelta
import datetime
import qrcode
import pdfkit

from xhtml2pdf import pisa
import requests

from PIL import Image
from django.http import FileResponse
import os


from tax.models import(
    user_receipts_details,
    tax_payment,
    view_v_tay_payments_full_details_1_a,
    
    )
class general:
    
    def getDateAfterDays(self, numberDays):
        new_date=''
        try:

            current_date = date.today()
            old_date = current_date #+ timedelta(days=-7)
            new_date = current_date + timedelta(days=180)
        except Exception as e:
            print("try catch error A0103: " + str(e))
        return new_date
    
    def convertDateToYMD(self, dateArg):
        dateYMD=''
        try:
            dateYMD=''
            #dDate=datetime.date.today()
            yYear=str(dateArg.year)
            mMonth=str(dateArg.month)
            dDay=str(dateArg.day)
            dateYMD=yYear + '-' + mMonth + '-' + dDay
        except Exception as e:
            print("try catch error A0107: " + str(e))
        
        return dateYMD
    
    def getTodayDate(self):
        todayDateStr=''
        try:
            todayDate=datetime.date.today()
            todayYear=str(datetime.date.today().year)
            todayMonth=str(datetime.date.today().month)
            todayDay=str(datetime.date.today().day)
            if len(todayMonth)==1:
                todayMonth='0' + todayMonth
            if len(todayDay)==1:
                todayDay='0' + todayDay

            todayDateStr= todayYear + '-' + todayMonth + '-' + todayDay
        except Exception as e:
            print("try catch error A0109: " + str(e))
        
        return todayDateStr

    def getTodayTime(self):
        todayTimeStr=''
        try:
            todayTime=datetime.datetime.now()
            todayHour=str(datetime.datetime.now().hour)
            todayMinute=str(datetime.datetime.now().minute)
            todaySecond=str(datetime.datetime.now().second)

            todayTimeStr= todayHour + ':' + todayMinute + ':' + todaySecond + '.000000'
        except Exception as e:
            print("try catch error A0121: " + str(e))
        
        return todayTimeStr
    
    def createQRCODEForReceiptOLD(self, receiptNumber):
        # import modules
        #import qrcode
        #from PIL import Image

        # taking image which user wants 
        # in the QR code center
        
        #Logo_link = 'g4g.jpg'//

        #logo = Image.open(Logo_link) //

        # taking base width
        basewidth = 100

        # adjust image size
        
        #wpercent = (basewidth/float(logo.size[0])) //
        #hsize = int((float(logo.size[1])*float(wpercent))) //
        #logo = logo.resize((basewidth, hsize), Image.ANTIALIAS) //
        msg=''
        try:
            QRcode = qrcode.QRCode(
	        error_correction=qrcode.constants.ERROR_CORRECT_H
            )

        # taking url or text
            url = 'https://www.geeksforgeeks.org/'

        # adding URL or text to QRcode
            QRcode.add_data(url)

        # generating QR code
            QRcode.make()

        # taking color name from user
        #QRcolor = 'Green'//
            QRcolor = 'Black'

        # adding color to QR code
            QRimg = QRcode.make_image(
	        fill_color=QRcolor, back_color="white").convert('RGB')

        # set size of QR code
        
        #pos = ((QRimg.size[0] - logo.size[0]) // 2, //
	    #(QRimg.size[1] - logo.size[1]) // 2) //
        #QRimg.paste(logo, pos) //

        # save the QR code generated
            QRimg.save(receiptNumber + '.png')

            print('QR code generated!')
            msg="QR code generated"
        except Exception as e:
            
                
            print("except=" + str(e))
            msg="error exception 123QWSA " + str(e)
                
            return msg
    
    
    def createQRCODEForReceipt(self, receiptNumber, usersId, taxPaymentId, totalCost):
        # import modules
        # taking image which user wants 
        # in the QR code center
        # taking base width
        msg=''
        try:
            basewidth = 100
            
            QRcode = qrcode.QRCode(
            	error_correction=qrcode.constants.ERROR_CORRECT_H
            )
            
            # taking url or text
            url = '{"reference": "' + receiptNumber + '", "total": "' + str(totalCost) + '"}'
            #https://www.geeksforgeeks.org/'
            
            # adding URL or text to QRcode
            QRcode.add_data(url)
            
            # generating QR code
            QRcode.make()
            
            # taking color name from user
            QRcolor = 'Green'
            
            # adding color to QR code
            QRimg = QRcode.make_image(
            	fill_color=QRcolor, back_color="white").convert('RGB')
            
            # set size of QR code
            #""" pos = ((QRimg.size[0] - logo.size[0]) // 2,
            #	(QRimg.size[1] - logo.size[1]) // 2)
            #QRimg.paste(logo, pos) """ #@//
            
            # save the QR code generated
            QRimg.save( str(receiptNumber) + '.png')
            
            #print('QR code generated!')
            inv=user_receipts_details(
                users_id= usersId,
                tax_payment_id= taxPaymentId,
                receipt_no=receiptNumber,
                status='Active',
                statusx='Active'
                )
            
            inv.save()
            msg='QRCODE successfully created'
        except Exception as e:
            
            #print("except=" + str(e))
            msg="error failed : " + str(e)
        return msg
        
    def removeImages(self, usersId, receiptNumber):
        x=0
        msg=""
        picName=""
        receiptNo=""
        
        try:
            todayDateStr=self.getTodayDate() + ' ' + self.getTodayTime()
            inv=tax_payment.objects.values().filter(users_id=usersId)#
            
            
            for ab in inv:
                paymentId=ab['id']
                
                ixc=user_receipts_details.objects.values().filter(users_id=usersId).exclude(receipt_no=receiptNumber)
                
                for ac in ixc:
                    receiptNo=ac['receipt_no']
                    picName= receiptNo + ".png"
                    if os.path.exists(picName):
                        os.remove(picName)
            msg="success"
        
        except Exception as e:
            msg="error failed : " + str(e)
        
        return msg
    
    
    
    def getTableHeaders(self, reportType):
        tableHeaders="""
            <tHead>
            <th>
            S/No
            </th>
            <th>
            Details
            </th>
            <th>
            Payers Name
            </th>
            <th>
            Collector
            </th>
            <th>
            Total Amount
            </th>
            <tHead>
            """
        return tableHeaders
        
    
    def getTableFooters(self, reportType):
        tableFooters="""
            <tFoot>
            <th>
            S/No
            </th>
            <th>
            Details
            </th>
            <th>
            Payers Name
            </th>
            <th>
            Collector
            </th>
            <th>
            Total Amount
            </th>
            <tFoot>
            """
        return tableFooters
    
    
    
    def getTableRows(self, fromDate, toDate, reportType):
        queryset=view_v_tay_payments_full_details_1_a.objects.values().filter(creation_date__gte=fromDate, creation_date__lte=toDate)
        
        tableRows="<tBody>"
        x=1
        for a in queryset:
            #
            tableRows+="""
                <tr>
                
                <td>
                """ + str(x) + """
                </td>
                
                <td>
                """ + a['details'] + """
                </td>
                
                <td>
                """ + a['name_of_payer'] + """
                </td>
                
                <td>
                """ + a['full_name'] + """
                </td>
                
                <td>
                """ + str(float(a['amount_paid'])*float(a['weight_units'])) + """
                </td>
                
                </tr>
                """
            x=x+1
        
        tableRows+="</tBody>"
        
        return tableRows
        
    def createHTMLForReport(self, fromDate, toDate, reportType,  dateStr):
        x=0
        msg=''
        try:
            
            tableHeaders=self.getTableHeaders(reportType)
            tableFooters=self.getTableFooters(reportType)
            tableRows=self.getTableRows(fromDate, toDate, reportType)
            
            body = """
            <html>
            <head>
            <meta name="pdfkit-page-size" content="Legal"/>
            <meta name="pdfkit-orientation" content="Landscape"/>
            <title>Tax payments report </title>
            </head>
            <body>
            """
            body +="Tax payments report from "  + fromDate
            body +="to " + toDate 
            body += "<br />"
            body += "<br />"
            body += "<table>"
            body +=tableHeaders + tableRows + tableFooters
            body +="</table> </body> </html>"
        
            pdf_path="report1-" +  dateStr + ".pdf"
            # Create PDF
            with open(pdf_path, "wb") as pdf_file:
                pisa_status = pisa.CreatePDF(body, dest=pdf_file)  
        except Exception as e:
            msg="except STV7052TVR993 " + str(e)
            
            #
            #print("except CVB5673YUI087=" + str(e))
        return msg
        
        
    def createPDFReport(self, fromDate, toDate, reportType, dateStr):
        x=0
        msg=''
        msg=self.createHTMLForReport(fromDate, toDate, reportType, dateStr)
        return msg
                
