from django.db import models

# Create your models here.
class login_category(models.Model):
    id = models.BigAutoField(primary_key=True)
    status=models.CharField(max_length=64)
    name=models.CharField(max_length=64)
    details=models.CharField(max_length=254, default="")

    def __str__(self):
        return self.id

class users(models.Model):
    id = models.BigAutoField(primary_key=True)
    #company= models.ForeignKey(company, on_delete=models.CASCADE, default="")
    first_name=models.CharField(max_length=32)
    middle_name=models.CharField(max_length=32)
    last_name=models.CharField(max_length=32)
    status=models.CharField(max_length=32)
    gender=models.CharField(max_length=16)
    mobile_number=models.CharField(max_length=16)
    user_email=models.EmailField(max_length=128)
    date_of_birth=models.DateTimeField()
    
    
        
    def __str__(self):
        return str(self.id)

class user_password(models.Model):
    id = models.BigAutoField(primary_key=True)
    users_id=models.ForeignKey(users, on_delete=models.CASCADE)
    status=models.CharField(max_length=64)
    password=models.CharField(max_length=256,)
    issue_date=models.DateTimeField(max_length=32, null=True)
    expire_date=models.DateTimeField(max_length=32,  null=True)

    def __str__(self):
        return self.id
###user_login_category ###user_login_category
class user_login_category(models.Model):
    id = models.BigAutoField(primary_key=True)
    users_id=models.ForeignKey(users, on_delete=models.CASCADE)
    login_category_id=models.ForeignKey(login_category, on_delete=models.CASCADE)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)





class roles(models.Model):
    id = models.BigAutoField(primary_key=True)
    #company= models.ForeignKey(company, on_delete=models.CASCADE, default="")
    name=models.CharField(max_length=32)
    status=models.CharField(max_length=32)
    details=models.CharField(max_length=32)
    
    
        
    def __str__(self):
        return str(self.id)


class user_roles(models.Model):
    id = models.BigAutoField(primary_key=True)
    users=models.ForeignKey(users, on_delete=models.CASCADE)
    roles=models.ForeignKey(roles, on_delete=models.CASCADE)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)
       
class weight_class(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=64)
    status=models.CharField(max_length=32)
    creation_date=models.DateTimeField(max_length=32, null=True)
    def __str__(self):
        return str(self.id)


class tax_source(models.Model):
    id = models.BigAutoField(primary_key=True)
    weight_class=models.ForeignKey(weight_class, on_delete=models.CASCADE, default=1)
    name=models.CharField(max_length=64)
    amount=models.DecimalField(max_digits=15, decimal_places=3)
    weight_measure=models.CharField(max_length=32)
    details=models.CharField(max_length=64)
    status=models.CharField(max_length=32)
    creation_date=models.DateTimeField(max_length=32, null=True)
    def __str__(self):
        return str(self.id)


class tax_source(models.Model):
    id = models.BigAutoField(primary_key=True)
    weight_class=models.ForeignKey(weight_class, on_delete=models.CASCADE, default=1)
    name=models.CharField(max_length=64)
    amount=models.DecimalField(max_digits=15, decimal_places=3)
    weight_measure=models.CharField(max_length=32)
    details=models.CharField(max_length=64)
    status=models.CharField(max_length=32)
    creation_date=models.DateTimeField(max_length=32, null=True)
    def __str__(self):
        return str(self.id)

class tax_payment(models.Model):
    id = models.BigAutoField(primary_key=True)
    tax_source=models.ForeignKey(tax_source, on_delete=models.CASCADE, default=1)
    users=models.ForeignKey(users, on_delete=models.CASCADE, default=1)
    name_of_payer=models.CharField(max_length=64)
    amount_paid=models.DecimalField(max_digits=15, decimal_places=3)
    weight_units=models.CharField(max_length=32)
    status=models.CharField(max_length=32)
    details=models.CharField(max_length=128)
    creation_date=models.DateTimeField(max_length=32, null=True)
    def __str__(self):
        return str(self.id)


class user_receipts_details(models.Model):
    id = models.BigAutoField(primary_key=True)
    users=models.ForeignKey(users, on_delete=models.CASCADE)
    tax_payment=models.ForeignKey(tax_payment, on_delete=models.CASCADE)
    receipt_no=models.CharField(max_length=256)
    status=models.CharField(max_length=64)
    statusx=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)
 



class view_v_user_details_1_a(models.Model):
    users_id = models.BigAutoField(primary_key=True)
    first_name= models.CharField(max_length=32)
    middle_name= models.CharField(max_length=32)
    last_name= models.CharField(max_length=32)
    full_name= models.CharField(max_length=64)
    gender= models.CharField(max_length=16)
    mobile_number= models.CharField(max_length=16)
    user_email= models.CharField(max_length=32)
    date_of_birth=models.DateTimeField(max_length=32, null=True)
    password_id= models.IntegerField()
    user_password=models.CharField(max_length=128)
    login_category_id= models.IntegerField()
    login_category_name=models.CharField(max_length=32)
    class Meta:
        managed = False
        db_table = "v_user_details_1_a"


class view_v_user_roles_1_a(models.Model):
    user_roles_id = models.BigAutoField(primary_key=True)
    first_name= models.CharField(max_length=32)
    middle_name= models.CharField(max_length=32)
    last_name= models.CharField(max_length=32)
    #full_name= models.CharField(max_length=64)
    roles_name= models.CharField(max_length=32)
    mobile_number= models.CharField(max_length=16)
    #user_email= models.CharField(max_length=32)
    roles_status=models.CharField(max_length=16)
    user_roles_status= models.CharField(max_length=16)
    users_status=models.CharField(max_length=16)
    roles_id= models.IntegerField()
    users_id=models.IntegerField()
    
    class Meta:
        managed = False
        db_table = "v_user_roles_1_a"


class view_v_payments_counter_1_a(models.Model):
    users_id = models.BigAutoField(primary_key=True)
    creation_date= models.DateTimeField(max_length=32, null=True)
    counter=models.IntegerField()
    
    class Meta:
        managed = False
        db_table = "v_payments_counter_1_a"
        

class view_v_tay_payments_full_details_1_a(models.Model):
    tax_id = models.BigAutoField(primary_key=True)
    users_id = models.IntegerField()
    #name_of_payer, amount_paid, weight_units,
    #a.creation_date, a.details,
    full_name= models.CharField(max_length=64)
    name_of_payer= models.CharField(max_length=32)
    details= models.CharField(max_length=64)
    tax_source_name= models.CharField(max_length=64)
    #gender= models.CharField(max_length=16)
    #a.details, b.name as tax_source_name, weight_measure,
    mobile_number= models.CharField(max_length=16)
    #user_email= models.CharField(max_length=32)
    creation_date=models.DateTimeField(max_length=32, null=True)
    #password_id= models.IntegerField()
    #user_password=models.CharField(max_length=128)
    amount_paid= models.DecimalField(max_digits=15, decimal_places=3)
    weight_units= models.DecimalField(max_digits=11, decimal_places=3)
    weight_measure=models.CharField(max_length=32)
    class Meta:
        managed = False
        db_table = "v_tay_payments_full_details_1_a"




