from rest_framework import serializers
from tax.models import(
login_category, users,  user_login_category,
user_password,
weight_class, tax_source, tax_payment,
view_v_user_details_1_a, 
)


class UsersSerializer(serializers.ModelSerializer):
    class Meta:
        model=users
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'first_name',
            'middle_name',
            'last_name',
            'status',
            'gender',
            'mobile_number',
            'user_email',
            'date_of_birth'
        )
    #company= models.ForeignKey(company, on_delete=models.CASCADE, default="")
    
class CreateUsersSerializer(serializers.ModelSerializer):
    class Meta:
        model=users
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'first_name',
            'middle_name',
            'last_name',
            'status',
            'gender',
            'mobile_number',
            'user_email',
            'date_of_birth'
        )
    #company= models.ForeignKey(company, on_delete=models.CASCADE, default="")
    #user_login_category

class UpdateUserSingleDetailSerializer(serializers.ModelSerializer):
    class Meta:
        model=users
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'users_id',
            'status',
            'first_name',
            
        )

class UpdateUserLoginCategorySerializer(serializers.ModelSerializer):
    class Meta:
        model=users
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'users_id',
            'status',
            'first_name',
            
        )
class LoginCategorySerializer(serializers.ModelSerializer):
    class Meta:
        model=login_category
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'id',
            'name',
            'status',
            'details',
        )
    #company= models.ForeignKey(company, on_delete=models.CASCADE, default="")
 
class CreateUserLoginCategorySerializer(serializers.ModelSerializer):
    class Meta:
        model=user_login_category
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'login_category_id_id',
            'users_id_id',
            'status',
        )



class CreateUserPasswordSerializer(serializers.ModelSerializer):
    class Meta:
        model=user_password
        #fields=('name', 'address','telephone', 'status')
        fields=( 
           	'status',
            'password',
            'issue_date',
            'expire_date',
            'users_id_id'	

        )



class UpdateUserPasswordSerializer(serializers.ModelSerializer):
    class Meta:
        model=user_password
        #fields=('name', 'address','telephone', 'status')
        fields=( 
           	'status',
            'password',
            'users_id_id'	
        )

class DeleteUserPasswordSerializer(serializers.ModelSerializer):
    class Meta:
        model=user_password
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'users_id_id'	
        )

class WeightClassSerializer(serializers.ModelSerializer):
    class Meta:
        model=weight_class
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'id',
            'name',
            'status',
            'creation_date'
        )

class UpdateWeightClassSerializer(serializers.ModelSerializer):
    class Meta:
        model=weight_class
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'id',
            'name',
            'status',
        )



class TaxSourceSerializer(serializers.ModelSerializer):
    class Meta:
        model=tax_source
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'id',
            'name',
            'amount',
            'weight_measure',
            'details',
            'status',
            'creation_date',
        )

class UpdateTaxSourceSingleDetailSerializer(serializers.ModelSerializer):
    class Meta:
        model=tax_source
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'id',
            'name',
            'status',
        )


class CreateTaxSourceSerializer(serializers.ModelSerializer):
    class Meta:
        model=tax_source
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'id',
            'name',
            'amount',
            'weight_measure',
            'details',
            'status',
            'creation_date',
        )
    #company= models.ForeignKey(company, on_delete=models.CASCADE, default="")
 
 


class TaxPaymentSerializer(serializers.ModelSerializer):
    class Meta:
        model=tax_payment
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'id',
            'tax_source',
            'users',
            'name_of_payer',
            'amount_paid',
            'weight_units',
            'status',
            'creation_date'
        )
    #company= models.ForeignKey(company, on_delete=models.CASCADE, default="")
 

class CreateTaxPaymentSerializer(serializers.ModelSerializer):
    class Meta:
        model=tax_payment
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'id',
            'tax_source',
            'users',
            'name_of_payer',
            'amount_paid',
            'weight_units',
            'status',
            'creation_date'
        )
    #company= models.ForeignKey(company, on_delete=models.CASCADE, default="")
 
class UsersDetailsSerializer(serializers.ModelSerializer):
    class Meta:
        model=view_v_user_details_1_a
        #fields=('name', 'address','telephone', 'status')
        fields=( 
    'users_id',#
    'first_name',#
    'middle_name',#
    'last_name',#
    'full_name',#
    'gender',#
    'mobile_number',#
    'user_email',#
    'date_of_birth',#
    'password_id',#
    'user_password',#
    'login_category_id',#
    'login_category_name',#
        )