from rest_framework import serializers
from tax.models import(
roles,
login_category, users,  user_login_category,
user_roles, 
user_password,
weight_class, tax_source, tax_payment,
view_v_user_details_1_a,  view_v_user_roles_1_a,
view_v_tay_payments_full_details_1_a,
)


class AllOfUsersRolesSerializer(serializers.ModelSerializer):
    class Meta:
        model=users
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'id',
            'first_name', #= models.CharField(max_length=32)
            'middle_name', #= models.CharField(max_length=32)
            'last_name', #= models.CharField(max_length=32)
             #full_name= models.CharField(max_length=64)
             'status',
             #=models.IntegerField()
        )
    #company= models.ForeignKey(company, on_delete=models.CASCADE, default="")


class AllUsersRolesSerializer(serializers.ModelSerializer):
    class Meta:
        model=view_v_user_roles_1_a
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'users_roles_id', # = models.BigAutoField(primary_key=True)
            'first_name', #= models.CharField(max_length=32)
            'middle_name', #= models.CharField(max_length=32)
            'last_name', #= models.CharField(max_length=32)
             #full_name= models.CharField(max_length=64)
            'roles_name', #= models.CharField(max_length=32)
            'mobile_number', #= models.CharField(max_length=16)
             #user_email= models.CharField(max_length=32)
            'roles_status', #=models.CharField(max_length=16)
            'user_roles_status', #= models.CharField(max_length=16)
            'users_status', #=models.CharField(max_length=16)
            'roles_id', #= models.IntegerField()
            'users_id', #=models.IntegerField()
        )
    #company= models.ForeignKey(company, on_delete=models.CASCADE, default="")

 
class UsersSerializer(serializers.ModelSerializer):
    class Meta:
        model=users
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'first_name',
            'middle_name',
            'last_name',
            'status',
            'gender',
            'mobile_number',
            'user_email',
            'date_of_birth'
        )   


class TaxPaymentsViewSerializer(serializers.ModelSerializer):
    class Meta:
        model=view_v_tay_payments_full_details_1_a
        #fields=('name', 'address','telephone', 'status')
        fields=(
        'tax_id',# = models.BigAutoField(primary_key=True)
        'users_id',# = models.IntegerField()
        #name_of_payer, amount_paid, weight_units,
        #a.creation_date, a.details,
        'full_name',#= models.CharField(max_length=64)
        'name_of_payer',#= models.CharField(max_length=32)
        'details',#= models.CharField(max_length=64)
        'tax_source_name',#= models.CharField(max_length=64)
        #gender= models.CharField(max_length=16)
        #a.details, b.name as tax_source_name, weight_measure,
        'mobile_number',#= models.CharField(max_length=16)
        #user_email= models.CharField(max_length=32)
        'creation_date',#=models.DateTimeField(max_length=32, null=True)
        #password_id= models.IntegerField()
        #user_password=models.CharField(max_length=128)
        'amount_paid',#= models.DecimalField(max_digits=15, decimal_places=3)
        'weight_units',#= models.DecimalField(max_digits=11, decimal_places=3)
        'weight_measure',#=models.CharField(max_length=32)
    )
class CreateUsersSerializer(serializers.ModelSerializer):
    class Meta:
        model=users
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'first_name',
            'middle_name',
            'last_name',
            'status',
            'gender',
            'mobile_number',
            'user_email',
            'date_of_birth'
        )
    #company= models.ForeignKey(company, on_delete=models.CASCADE, default="")
    #user_login_category

class UpdateUserSingleDetailSerializer(serializers.ModelSerializer):
    class Meta:
        model=users
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'users_id',
            'status',
            'first_name',
            
        )

class UpdateUserLoginCategorySerializer(serializers.ModelSerializer):
    class Meta:
        model=users
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'users_id',
            'status',
            'first_name',
            
        )
        
        
###

class RolesSerializer(serializers.ModelSerializer):
    class Meta:
        model=roles
        
        fields=( 
            'id',
            'name',
            'status',
            'details',
        )
  

class UserRolesSerializer(serializers.ModelSerializer):
    class Meta:
        model=user_roles
        
        fields=( 
            'users_id',
            'roles_id',
            'status',
        )
   



###


class LoginCategorySerializer(serializers.ModelSerializer):
    class Meta:
        model=login_category
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'id',
            'name',
            'status',
            'details',
        )
    #company= models.ForeignKey(company, on_delete=models.CASCADE, default="")
 
class CreateUserLoginCategorySerializer(serializers.ModelSerializer):
    class Meta:
        model=user_login_category
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'login_category_id_id',
            'users_id_id',
            'status',
        )



class CreateUserPasswordSerializer(serializers.ModelSerializer):
    class Meta:
        model=user_password
        #fields=('name', 'address','telephone', 'status')
        fields=( 
           	'status',
            'password',
            'issue_date',
            'expire_date',
            'users_id_id'	

        )



class UpdateUserPasswordSerializer(serializers.ModelSerializer):
    class Meta:
        model=user_password
        #fields=('name', 'address','telephone', 'status')
        fields=( 
           	'status',
            'password',
            'users_id_id'	
        )

class DeleteUserPasswordSerializer(serializers.ModelSerializer):
    class Meta:
        model=user_password
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'users_id_id'	
        )

class WeightClassSerializer(serializers.ModelSerializer):
    class Meta:
        model=weight_class
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'id',
            'name',
            'status',
            'creation_date'
        )

class UpdateWeightClassSerializer(serializers.ModelSerializer):
    class Meta:
        model=weight_class
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'id',
            'name',
            'status',
        )



class TaxSourceSerializer(serializers.ModelSerializer):
    class Meta:
        model=tax_source
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'id',
            'name',
            'amount',
            'weight_measure',
            'details',
            'status',
            'creation_date',
        )

class UpdateTaxSourceSingleDetailSerializer(serializers.ModelSerializer):
    class Meta:
        model=tax_source
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'id',
            'name',
            'status',
        )


class CreateTaxSourceSerializer(serializers.ModelSerializer):
    class Meta:
        model=tax_source
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'id',
            'name',
            'amount',
            'weight_measure',
            'details',
            'status',
            'creation_date',
        )
    #company= models.ForeignKey(company, on_delete=models.CASCADE, default="")
 
 


class TaxPaymentSerializer(serializers.ModelSerializer):
    class Meta:
        model=tax_payment
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'id',
            'tax_source',
            'users',
            'name_of_payer',
            'amount_paid',
            'weight_units',
            'status',
            'creation_date'
        )
    #company= models.ForeignKey(company, on_delete=models.CASCADE, default="")
 

class CreateTaxPaymentSerializer(serializers.ModelSerializer):
    class Meta:
        model=tax_payment
        #fields=('name', 'address','telephone', 'status')
        fields=( 
            'id',
            'tax_source',
            'users',
            'name_of_payer',
            'amount_paid',
            'weight_units',
            'status',
            'creation_date'
        )
    #company= models.ForeignKey(company, on_delete=models.CASCADE, default="")
 
class UsersDetailsSerializer(serializers.ModelSerializer):
    class Meta:
        model=view_v_user_details_1_a
        #fields=('name', 'address','telephone', 'status')
        fields=( 
    'users_id',#
    'first_name',#
    'middle_name',#
    'last_name',#
    'full_name',#
    'gender',#
    'mobile_number',#
    'user_email',#
    'date_of_birth',#
    'password_id',#
    'user_password',#
    'login_category_id',#
    'login_category_name',#
        )