"""health_clinic_is_01 URL Configuration

The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/4.0/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  path('', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  path('', Home.as_view(), name='home')
Including another URLconf
    1. Import the include() function: from django.urls import include, path
    2. Add a URL to urlpatterns:  path('blog/', include('blog.urls'))
"""
from django.urls import path
from tax.views import (
usersView, 
CreateUsersView, UpdateUsersView, DeleteUsersView,
loginCategoryView, CreateUserLoginCategoryView,
CreateUserPasswordView, WeightClassView, 
CreateTaxSourceView, UpdateTaxSourceView, DeleteTaxSourceView,
TaxSourceView, TaxPaymentView, CreateTaxPaymentView, 
UsersDetailsView, UpdateUserPasswordView,

CreateRolesView,
#userRolesDetailsView,
#UserRolesViewSerializer,
#UserRolesDetailsView,
CreateUserRolesView,
DeleteUserRoleView,

RolesView, 
UserRolesDisplayView,
##UserRolesDisplayView
SingleUserRolesView,

AllOfUsersRolesView,

TaxPaymentsView,

TaxPaymentsReports1View,
TaxPaymentsReports1ViewGD,


UserLoginView,

Report1PdfView,
)

urlpatterns = [
    #path('api/home', driverView.as_view()), UsersDetailsView
    ### Report1PdfView
    
    path('tax/usersViewEXT', usersView.as_view()),
    path('tax/usersDetailsViewEXT', UsersDetailsView.as_view()),
    
    path('tax/userLoginViewEXT', UserLoginView.as_view()),
    
    path('tax/createUsersViewEXT', CreateUsersView.as_view()),
    path('tax/updateUsersViewEXT', UpdateUsersView.as_view()),
    path('tax/deleteUsersViewEXT', DeleteUsersView.as_view()),
    
    
    path('tax/TaxPaymentsViewEXT/<str:fromDate>/<str:toDate>/', TaxPaymentsView.as_view()),
    
    path('tax/TaxPaymentsReports1ViewEXT/<str:fromDate>/<str:toDate>/', TaxPaymentsReports1View.as_view()),
    
    path('tax/TaxPaymentsReports1ViewGDEXT/<str:fromDate>/<str:toDate>/', TaxPaymentsReports1ViewGD.as_view()),
    ### TaxPaymentsReports1View TaxPaymentsReports1ViewGD
    
    path('tax/Report1PdfViewEXT/<str:fromDate>/<str:toDate>/<str:dateStr>/', Report1PdfView.as_view()),
    
    path('tax/CreateRolesViewEXT', CreateRolesView.as_view()),
    #path('tax/UserRolesDetailsViewEXT', UserRolesDetailsView.as_view()),
    path('tax/CreateUserRolesViewEXT', CreateUserRolesView.as_view()),
    
    path('tax/DeleteUserRoleViewEXT', DeleteUserRoleView.as_view()),
    
    #RolesView
    path('tax/RolesViewEXT', RolesView.as_view()),
    
    path('tax/UserRolesDisplayViewEXT', UserRolesDisplayView.as_view()),
    
    ###AllOfUsersRolesView DeleteUserRoleView   SingleUserRolesView
    
    path('tax/SingleUserRolesViewEXT/<str:usersId>/', SingleUserRolesView.as_view()),
    
    
    
    path('tax/AllOfUsersRolesViewEXT', AllOfUsersRolesView.as_view()),
    
    
    path('tax/loginCategoryViewEXT', loginCategoryView.as_view()),
    path('tax/createUserLoginCategoryViewEXT', CreateUserLoginCategoryView.as_view()),
    path('tax/createUserPasswordViewEXT', CreateUserPasswordView.as_view()),
    path('tax/weightClassViewEXT', WeightClassView.as_view()),
    
    path('tax/createTaxSourceViewEXT', CreateTaxSourceView.as_view()),
    path('tax/UpdateTaxSourceViewEXT', UpdateTaxSourceView.as_view()),
    path('tax/DeleteTaxSourceViewEXT', DeleteTaxSourceView.as_view()),
    
    path('tax/taxSourceViewEXT', TaxSourceView.as_view()),
    path('tax/createTaxPaymentViewEXT', CreateTaxPaymentView.as_view()),
    path('tax/taxPaymentViewEXT', TaxPaymentView.as_view()),
    path('tax/updateUserPasswordViewEXT', UpdateUserPasswordView.as_view()),
    ###  UpdateUserPasswordView
    #path('api/smsGenerator/createSMSViewV,', createSMSViewV.as_view(), name="createSMSViewV"),  TaxSourceView
    ###CreateUserPasswordView   WeightClassView
    ##newEntryTokenView
]
